; Al,
; This is a very rough draft of a doc that will eventually be available to
; the public as a TI.  Take it and use it as a reference.  Enjoy!!!
;
; Sincerely, Bill Martinez

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

;In previous versions of Paradox, lookup routines generally consisted of
;storing some lookup value into a variable and moving to a lookup table to
;do a LOCATE.  If retval is true, the record or field values are copied
;back to the table of origin.  This is a simplified example and not all too
;generic.  However, using COPYTODYNARRAY/COPYFROMDYNARRAY makes for compact,
;fast code.  

;When a record is copied to a dynarray, it stores not only the field values
;but the field name and type as well.  This eliminates the need for a
;compatible or like structure between tables.  If an element in the dynarray
;matches, it is inserted into the matching field of the current record.  If
;the element does not match, it is ignored (see the Upgrade Guide for more
;information on COPYTODYNARRAY/COPYFROMDYNARRAY).  This is especially
;helpful when used in conjunction with GETRECORD.

;GETRECORD is used in much the same way LOCATE is used.  Consider the
;following code sample:

;VIEW TableName
;LOCATE Field1, Field2
;IF RETVAL THEN
;    COPYTODYNARRAY ArrayName   ; Or COPYTOARRAY ArrayName
;ELSE
;    DYNARRAY ArrayName[]       ; Or Array
;                               ; Variable[NFIELDS(TableName)]+1
;ENDIF 
;CLEARIMAGE

;Now, consider the next code sample using GETRECORD:

;GETRECORD "TableName" Field1, Field2 TO DYNARRAY DynArrayName

;Note that the Table does not need to be on the workspace.  Plus, it can be
;executed in any system mode and it will always allocate Array.
 
proc helpfill()
        if retval then
           copyfromdynarray TrueVal
           return 1
           else message "Not one of the possible values." sleep 500
                moveto "films"
                window create image TO TabWin
                wait table until "F2",27
                     switch case retval="F2":
                                 postrecord
                                 copytodynarray TrueVal
                                 window destroy 
                                 moveto "maintabl"
                                 copyfromdynarray TrueVal         
                             case retval=27:
                                 window destroy 
                                 moveto "maintabl"
                     endswitch
                return 1
           endif
endproc      
     
PROC waitproc(Ttype,Erecord,Cnumber)
switch 
case Ttype="DEPARTFIELD":
     if field()="Title" and isblank([Title]) then 
        message "A value must be provided for this field." sleep
1000
        return 1
        else if field()="Title" and NOT isBlank([Title]) then
        getrecord "Films" [Title] to dynarray TrueVal
                helpfill()
                return 0
                else return 0
             endif   
     endif
case Erecord["TYPE"]="KEY":
     If Erecord["KEYCODE"]=ASC("F1") and NOT isFieldView() then
        getrecord "Films" [Title] to dynarray TrueVal
        helpfill()
        return 1
     else    
        message errormessage() sleep 1000
     endif
     If Erecord["KEYCODE"]=ASC("F2") then
        do_It!
     endif           
     if Erecord["KEYCODE"]=ASC("Esc") then 
        return 2
     endif   
otherwise: return 0
endswitch
endproc

VIEW NOWINDOW "Films" 
LookUpTabl=Table()
COEDIT "Maintabl"
MainTable=Table()
WAIT WORKSPACE
PROC "WaitProc"
TRIGGER "DEPARTFIELD"
KEY "F1","F2","Esc"
ENDWAIT
Do_It!
ClearAll        